/***************************************************************************
 *   Copyright (C) 2007 by Eric ALBER                                      *
 *   eric.alber@gmail.com                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <QtWui/QwuiFileRessourceProvider>
#include <QtNetwork/QHttpRequestHeader>
#include <QtWui/QwuiFileRessource>

QwuiFileRessourceProvider::QwuiFileRessourceProvider(const QString& sessionId) :
    QwuiAbstractRessourceProvider(sessionId),
    m_rootDir(".")
{
}

QwuiFileRessourceProvider::~QwuiFileRessourceProvider()
{
}

QwuiAbstractRessource* QwuiFileRessourceProvider::provide(const QHttpRequestHeader& header, const QString& postContent)
{
    Q_UNUSED(postContent);

    return new QwuiFileRessource(m_rootDir + header.path());
}

void QwuiFileRessourceProvider::setRootDirectory(const QString& path)
{
    m_rootDir = path;
}

QString QwuiFileRessourceProvider::rootDirectory() const
{
    return m_rootDir;
}
